
/*

Copyright (C) 2015 Dirk Schuetz <dirk.schuetz@durham.ac.uk> and Lewin Strauss

    This file is part of KnotJob.

    KnotJob is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    KnotJob is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/**
 * A library of elementary mathematical operations.
 */
public class BasicMaths {
 
    /**
     * Calculates the absolute value of an integer.
     */
    public static int absVal(int x) {
        if (x < 0) x = -x;
        return x;
    }
    
    /**
     * Calculates integer x in modulo n.
     */
    public static int mod_n(int x, int n) { // check n=0-case
        x = x % n;
        if (x < 0) x += n;
        return x;
    }
    
    /**
     * Determines the smaller one of two integers a and b.
     */
    public static int min(int a, int b) {
        int min = b;
        if (a < b) min = a;
        return min;
    }
    
    
    public static void main(String[] args) {
        int i = 7;
        System.out.println(i);
        mod_n(i,4);
        System.out.println(i);
        i = mod_n(i,4);
        System.out.println(i);
        System.out.println(mod_n(8,4));
    }  
}
